<template>
	<div class="q-pa-md pageCentreClass">
		<q-form @submit="onSubmit" class="q-gutter-md">
			<q-list padding>
				<div>{{ $t('account.username') }}</div>
				<q-input filled v-model="name" lazy-rules :rules="nameRules()" />
				<q-separator spaced />
				<div>{{ $t('account.password') }}</div>
				<q-input v-model="password1" filled :type="isPwd1 ? 'password' : 'text'" :rules="nameRules()">
					<template v-slot:append>
						<q-icon
							:name="isPwd1 ? 'visibility_off' : 'visibility'"
							class="cursor-pointer"
							@click="isPwd1 = !isPwd1"
						/>
					</template>
				</q-input>
				<div v-if="error">{{errorMsg}}</div>
				<div>
					<q-btn label="Login" type="submit" color="primary" />
					<q-btn
						:label="$t('account.forgetPassword')"
						@click="forgotPw"
						color="primary"
						flat
						class="q-ml-sm"
					/>
				</div>
			</q-list>
		</q-form>
	</div>
</template>

<script>
	import loginFn from "../js/loginFunctions";
	import { eventBus } from "../js/event";
	import fetchFn from "../js/fetch";
	export default {
		name: "loginComponent",
		data() {
			return {
				name: "",
				password1: "",
				isPwd1: true,
				error: false,
				errorMsg: ""
			};
		},
		methods: {
			forgotPw() {
				this.$router.push({ path: "/resetpassword" });
			},
			onSubmit: async function(event) {
				this.error = false;
				event.preventDefault();
				let responsePromise = fetchFn.getUserById(this.name);

				let toHash = this.password1 + this.name;
				let hash = loginFn.hash(toHash);
				let token = "";

				let user = await responsePromise;

				if (user.passwordHash === hash) {
					token = loginFn.generateLoginToken(this.name);

					let date = new Date();
					date.setDate(date.getDate() + 7);

					user["activeTokens"].push({
						token: token,
						validUntil: date
					});

					let resp = await fetchFn.putUser(user);
					if (!resp) {
						this.error = true;
					}
				} else {
					this.error = true;
				}

				if (this.error) {
					this.errorMsg = this.$i18n.t("error.loginFailed");
					return;
				}
				this.$q.cookies.set("loginToken", token, {
					expires: 14,
					path: "/"
				});
				eventBus.$emit("tokenSet", token);

				this.$fire({
					title: this.$i18n.t("success"),
					type: "success",
					timer: 2500
				});
				this.$emit("success", true);
			},
			nameRules: function() {
				return [
					val =>
						(val && val.length > 0) ||
						this.$i18n.t("error.typeSomething")
				];
			}
		}
	};
</script>

<style scoped>
	.pageCentreClass {
		width: 100%;
		padding: 1em 10% 0 10%;
	}
</style>
